!C***************************************************************
!C
!(JA(NA0),BLKSTR,NJNTS,NBPTS,NDF,NCN,ITYPE,NMBS,NHIP,NECU,MBAN)
      SUBROUTINE BACKS(NECU,MBAN,NHIP,LONGA,A)
!C BANDED SYMETRIC LINEAR SYSTEM OF EQUATIONS SOLVER BACK
!C SUBSTITUTION PHASE
 !     INCLUDE 'BIG1.F'
      USE FILE_USE
      INTEGER :: NECU,MBAN,NHIP,LONGA,NT,NE,NT1,I1,INI2,I,I2,I3,I4,NE1,NI1
      INTEGER :: NH2,I5,I6,I7,IDIAG,ITER
      REAL :: A(LONGA),TER !A(1)
      NT=MBAN+NHIP
!C DIVISION OF THE CORE INTO TWO BLOCKS
      I1=MBAN*NHIP
      NE=1
      NT1=I1+NT
1     IF(NT1+NT+NHIP.GT.LONGA) GO TO 2
      NE=NE+1
      I1=I1+NHIP
      NT1=NT1+NT+NHIP
      GO TO 1
2     IF(NE.LT.NECU) GO TO 3
      NE=NECU
      I1=(NECU+MBAN-1)*NHIP
      NT1=NECU*NT+I1
3     INI2=NE*NT+1
!C FILL THE SECOND BLOCK WITH ZEROES
      DO 5 I=INI2,NT1
5     A(I)=0
      NI1=NECU+1
10    NI1=NI1-NE
      NE1=NE
      IF(NI1.LT.1) NE1=NE1+NI1-1
!C CHECK IF THERE REMAIN ENOUGH EQUATIONS IN THE SYSTEM TO FILL
!C THE FIRST BLOCK
      IF(NI1.LT.1) NI1=1
      I2=(NE-NE1)*NT+1
!C BRING FROM THE DISK THE EQUATIONS OF THE FIRST BLOCK
      CALL TRANSF(NF1,0,NI1,NE1,NT,I2,A)
      NH2=NE*NHIP
!C SHIFT DOWN THE SECOND MEMBERS IN THE SECOND BLOCK TO LEAVE
!C SPACE FOR THE NEWCOMERS
      DO 11 I=NT1-NH2,INI2,-1
11    A(I+NH2)=A(I)
      I3=INI2-1
!C ALLOCATE THE SECOND MEMBERS IN THE FIRST BLOCK INTO THE
!C SECOND BLOCKS
      DO 12 I4=1,NE
        I5=(I4-1)*NT+MBAN
        DO 13 I6=1,NHIP
          I7=I5+I6
          I3=I3+1
          A(I3)=A(I7)
13      CONTINUE
12    CONTINUE
      DO 14 NE3=NE,NE-NE1+1,-1
        IDIAG=(NE3-1)*NT+1
        ITER=INI2+(NE3-1)*NHIP
       !EXECUTE BACK SUBSTITUTION
        DO 15 IHIP=1,NHIP
          I3=ITER+IHIP-1
          I6=I3
          I4=IDIAG
          TER=A(I3)
          DO 16 I5=1,MBAN-1
            I3=I3+NHIP
            I4=I4+1
            TER=TER-A(I3)*A(I4)
16        CONTINUE
          A(I6)=TER/A(IDIAG)
15      CONTINUE
14    CONTINUE
      I3=INI2+(NE-NE1)*NHIP
!C SEND THE RESULTS TO FILE 2 IN DISK
      CALL TRANSF(NF2,1,NI1,NE1,NHIP,I3,A)
      IF(NI1.GT.1) GO TO 10
17    CONTINUE
      RETURN
      END
 
